% This script  is an MPC subject to Noise, 
% noise can be simply removed by commenting it out 

% This  script uses optProblem_net128_test0412,
% plotStatesGL_test0412,network128... 


% addpath('C:\Users\sarriyh\Downloads\casadi-matlabR2014b-v3.2.3')
% import casadi.*

clc
clear 
close all 



% Definig all constants for each model PI,P_res,GOR, WC,K_pr
GOR     = [0.15 ; 0.1 ; 0.15];     % for [well1 well2 well3]
WC      = [0.15 ; 0.1 ; 0.05];     % for [well1 well2 well3]
Kpr     = [2.8  ; 3.0 ; 3.2 ;3.4]; % for [well1 well2 well3 riser]

p=[GOR(1),WC(1),Kpr(1),...  % for well1 
   GOR(2),WC(2),Kpr(2),...  % for well2
   GOR(3),WC(3),Kpr(3),...  % for well3 
   Kpr(4)];                 % for riser



x0 =[3.1933 0.5850 4.4132 3.3977 0.5601 5.0101 3.1600 0.5846 4.2971 0.2646 1.2903]';
  
z0 =[15.6427 1.0425 15 14.3927 1.1855 20 14.6892 1.0511 28 48.0037 8.5439 39.4598 48.0963]';
u0 =[1;0.5;1;0.6;1;0.5;1];


% Steady state values from RTO 
[xSS,uSS] = RTO_network128([x0;z0],u0,p);


% Pridiction horizon and run time
T        = 4000;
%  T        = 200;
Nmpc     = 20; 
% Nmpc=200;
Nopt     = 20;
ode_time = T/Nopt;


% Initialization 
xz_append    =[];
xz0_measured =[x0;z0];
u_opt_append =[];
outputs_append=[];


% MPC itiration 
tic
for i=1:Nmpc
    fprintf('\n MPC iteration = %d \n',i);
    % run optimization 
[w,w0,J,u_nlp_opt,x_nlp_opt] = optProblem_net128_test0412(Nopt,u0,p,x0,z0,xz0_measured,uSS,xSS);


    % extract control input 
u_opt=u_nlp_opt(:,1);
u_ode= u_opt;
u_opt_append=[u_opt_append,u_ode];


    % Run Ode15s
M=diag([ones(1,11) zeros(1,13)]);
options=odeset('Mass',M);


FF= @(t,x) [eye(24,24) zeros(24,25)]*network_128(0,x,u_ode,p);



tspan=0:1:ode_time-1; 
    % [t,xz] = ode15s(FF,tspan,[x0;z0],options);
[t,xz] = ode15s(FF,tspan,xz0_measured,options);

    % extract states and time
xz_append =[xz_append;xz];



    % update xz0_measured
xz0_measured=[xz(end,:)]';

%noise !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
%     % noise creation  low order 
% noise=zeros(24,1);
% noise(2)=rand(1)*1e-4; %mass gass well 1 
% noise(5)=rand(1)*1e-4; % "        well 2
% noise(8)=rand(1)*1e-4; % "        well 3
% noise(10)=rand(1)*1e-4; % "        riser
% 
% noise(1)=rand(1)*1e-3; %        
% noise(3)=rand(1)*1e-3; % 
% noise(4)=rand(1)*1e-3; % 
% noise(6)=rand(1)*1e-3; % 
% noise(7)=rand(1)*1e-3; % 
% noise(9)=rand(1)*1e-3; % 
% noise(11)=rand(1)*1e-3; % 

    % noise creation  high order 
noise=zeros(24,1);
noise(2)=rand(1)*1e-3; %mass gass well 1 
noise(5)=rand(1)*1e-3; % "        well 2
noise(8)=rand(1)*1e-3; % "        well 3
noise(10)=rand(1)*1e-3; % "        riser

noise(1)=rand(1)*1e-2; %        
noise(3)=rand(1)*1e-2; % 
noise(4)=rand(1)*1e-2; % 
noise(6)=rand(1)*1e-2; % 
noise(7)=rand(1)*1e-2; % 
noise(9)=rand(1)*1e-2; % 
noise(11)=rand(1)*1e-2; % 
xz0_measured=xz0_measured+noise;
%noise !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

for n=1:1:ode_time
    % Passing extra parameters
panda=network_128(0,(xz(n,:))',u_ode,p);
    % Removing [differentials;residuals] 
panda(1:24)=[];
    % Appending outputs 
outputs_append=[outputs_append,panda];
end
end
toc

outputs_append=outputs_append';


%save('plant_NMPC_high_noise.mat','uSS','xSS','outputs_append','xz_append', 'u_opt_append','t','p','u0','x0','z0')
