% This script  is an MPC subject to disturbance 



% This  script uses optProblem_net128_test0412,
% plotStatesGL_test0412,network128... 


% addpath('C:\Users\sarriyh\Downloads\casadi-matlabR2014b-v3.2.3')
% import casadi.*

clc
clear 
close all 

x0 =[3.1933 0.5850 4.4132 3.3977 0.5601 5.0101 3.1600 0.5846 4.2971 0.2646 1.2903]';
  
z0 =[15.6427 1.0425 15 14.3927 1.1855 20 14.6892 1.0511 28 48.0037 8.5439 39.4598 48.0963]';
u0 =[1;0.5;1;0.6;1;0.5;1];

% Initialization 
xz_append    =[];
xz0_measured =[x0;z0];
u_opt_append =[];
outputs_append=[];
RTO_xSS_append=[];  %to see changes in xSS
RTO_uSS_append=[];  %to see changes in uSS
WC_append=[];       %water cut append to see the changes 
GOR_append=[];      %Gas oil ration to see changes 
% Pridiction horizon and run time
T        = 4000;
Nmpc     = 10; 
Nopt     = 20;
ode_time = T/Nopt;
tic

for inc=[0:10:30]
% begin !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
% Definig all constants for each model PI,P_res,GOR, WC,K_pr
GOR     = [0.15 ; 0.1 ; 0.05];     % for [well1 well2 well3]
WC      = [0.15 ; 0.1 ; 0.05]*(1+(inc/100));     % for [well1 well2 well3]
Kpr     = [2.8  ; 3.0 ; 3.2 ;3.4]; % for [well1 well2 well3 riser]

p=[GOR(1),WC(1),Kpr(1),...  % for well1 
   GOR(2),WC(2),Kpr(2),...  % for well2
   GOR(3),WC(3),Kpr(3),...  % for well3 
   Kpr(4)];                 % for riser
%End !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
WC_append=[WC_append,WC];
GOR_append=[GOR_append,GOR];


% Steady state values from RTO 
[xSS,uSS] = RTO_network128([x0;z0],u0,p);

RTO_xSS_append=[RTO_xSS_append,xSS];
RTO_uSS_append=[RTO_uSS_append,uSS];




% MPC itiration 

for i=1:Nmpc
    fprintf('\n MPC iteration = %d \n',i);
    % run optimization 
[w,w0,J,u_nlp_opt,x_nlp_opt] = optProblem_net128_test0412(Nopt,u0,p,x0,z0,xz0_measured,uSS,xSS);


    % extract control input 
u_opt=u_nlp_opt(:,1);
u_ode= u_opt;
u_opt_append=[u_opt_append,u_ode];


    % Run Ode15s
M=diag([ones(1,11) zeros(1,13)]);
options=odeset('Mass',M);

%  begin p !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
FF= @(t,x) [eye(24,24) zeros(24,25)]*network_128(0,x,u_ode,p);
%   end  p !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


tspan=0:1:ode_time-1; 
    % [t,xz] = ode15s(FF,tspan,[x0;z0],options);
[t,xz] = ode15s(FF,tspan,xz0_measured,options);

    % extract states and time
xz_append =[xz_append;xz];


    % update xz0_measured
xz0_measured=[xz(end,:)]';   % when adding noise cancel this



for n=1:1:ode_time
    % Passing extra parameters
panda=network_128(0,(xz(n,:))',u_ode,p);
    % Removing [differentials;residuals] 
panda(1:24)=[];
    % Appending outputs 
outputs_append=[outputs_append,panda];
end
end



end
toc
outputs_append=outputs_append';

%save('plant_NMPC_disturbance_WC_test.mat','RTO_xSS_append','RTO_uSS_append','outputs_append','xz_append','u_opt_append','GOR_append','WC_append','t','T','p','u0','x0','z0')
%save('plant_NMPC_disturbance_GOR_test.mat','RTO_xSS_append','RTO_uSS_append','outputs_append','xz_append','u_opt_append','GOR_append','WC_append','t','T','p','u0','x0','z0')
