function [xSS,uSS]=RTO_network128(x0,u0,p)


% clc; 
% clear; df
% close all;

addpath('C:\Users\sarriyh\Downloads\casadi-matlabR2014b-v3.2.3')

import casadi.*


% in this case the upper and lower bound of the production choke of the
% riser are equal such that is always open. in addition the objective
% function is to minimize injected gas and maximize oil production from
% riser.

 % defining symbolic variables 
 
 % well 1
 x1  = MX.sym('x1');  % Mass of gas in annulus
 x2  = MX.sym('x2');  % Mass of  gas in tubing
 x3  = MX.sym('x3');  % Mass of liquid in tubing
 % well 2
 x4  = MX.sym('x4'); % Mass of gas in annulus
 x5  = MX.sym('x5'); % Mass of  gas in tubing
 x6  = MX.sym('x6'); % Mass of liquid in tubing
  
 % well 3
 x7  = MX.sym('x7');  % Mass of gas in annulus
 x8  = MX.sym('x8');  % Mass of  gas in tubing
 x9  = MX.sym('x9');  % Mass of liquid in tubing

 % riser 
 x10 = MX.sym('x10'); % Mass of gas in tubing 
 x11 = MX.sym('x11'); % Mass of liquid in tubing
 
 % algebraic variables 
 
 % well 1 
 x12 = MX.sym('x12'); % Inflow of gas injection
 x13 = MX.sym('x13'); % Total outflow from reservoir
 x14 = MX.sym('x14'); % Total outflow from tubing
 
 % well 2 
 x15 = MX.sym('x15'); % Inflow of gas injection
 x16 = MX.sym('x16'); % Total outflow from reservoir
 x17 = MX.sym('x17'); % Total outflow from tubing
 
 % well 3 
 x18 = MX.sym('x18'); % Inflow of gas injection
 x19 = MX.sym('x19'); % Total outflow from reservoir
 x20 = MX.sym('x20'); % Total outflow from tubing
 
 x21 = MX.sym('x21'); % Total outflow
 x22 = MX.sym('x22'); % Gas outflow
 x23 = MX.sym('x23'); % Liquid outflow
 x24 = MX.sym('x24'); % Manifold pressure

 x = [x1;x2;x3;x4;x5;x6;x7;x8;x9;x10;x11;x12;x13;x14;...
      x15;x16;x17;x18;x19;x20;x21;x22;x23;x24];
  
u1 = MX.sym('u1');
u2 = MX.sym('u2');
u3 = MX.sym('u3');
u4 = MX.sym('u4');
u5 = MX.sym('u5');
u6 = MX.sym('u6');
u7 = MX.sym('u7');

u=[u1;u2;u3;u4;u5;u6;u7];

%!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
% is that even correct ?????? i get the same solution

% Definig all constants to each model PI,P_res,GOR, WC,K_pr
% GOR     = [0.15 ; 0.1 ; 0.15];     % for [well1 well2 well3]
% WC      = [0.15 ; 0.1 ; 0.05];     % for [well1 well2 well3]
% Kpr     = [2.8  ; 3.0 ; 3.2 ;3.4]; % for [well1 well2 well3 riser]
% 
% p=[GOR(1),WC(1),Kpr(1),...
%    GOR(2),WC(2),Kpr(2),...
%    GOR(3),WC(3),Kpr(3),...
%    Kpr(4)];
%!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


model  = network_128(0,x,u,p);
diff   = model(1:11);
alg    = model(12:24);
%L      = model(25) ;
% lbg  = zeros(24,1);
% ubg  = lbg;



% lower and upper bounds x(diff and alg) and u  x1..x24 represent the same
% quantities presented above 

%diff wells and riser 
x1_lb  = 1e-3;
x2_lb  = 1e-3;
x3_lb  = 1e-3;
x4_lb  = 1e-3;
x5_lb  = 1e-3;
x6_lb  = 1e-3;
x7_lb  = 1e-3;
x8_lb  = 1e-3;
x9_lb  = 1e-3;
x10_lb = 1e-3;
x11_lb = 1e-3;
%algebraic wells
x12_lb = 1e-2;
x13_lb = 1e-2;
x14_lb = 1e-2;
x15_lb = 1e-2;
x16_lb = 1e-2;
x17_lb = 1e-2;
x18_lb = 1e-2;
x19_lb = 1e-2;
x20_lb = 1e-2;
%algebraic riser
x21_lb = 1e-2;
x22_lb = 1e-2;
x23_lb = 1e-2;
%manifold pressure 
x24_lb = 0.1;


%DOF riser and wells production chokes and gas injection chokes 
u1_lb=0.1;
u2_lb=0.1;
u3_lb=0.1;
u4_lb=0.1;
u5_lb=0.1;
u6_lb=0.1;
u7_lb=1;
% setting the above in a vertical concatenation( a seriec of inconnected
% things)
lbx = vertcat(x1_lb,x2_lb,x3_lb,x4_lb,x5_lb,x6_lb,x7_lb,x8_lb,x9_lb,x10_lb,x11_lb,...
    x12_lb,x13_lb,x14_lb,x15_lb,x16_lb,x17_lb,x18_lb,x19_lb,x20_lb,x21_lb,x22_lb,x23_lb,x24_lb);

lbu = vertcat(u1_lb,u2_lb,u3_lb,u4_lb,u5_lb,u6_lb,u7_lb);


% same as above only for UPPER bounds as can be seen the production is
% relaxed by allowing the bounds to be very large
x1_ub  = 10e7;
x2_ub  = 10e7;
x3_ub  = 10e7;
x4_ub  = 10e7;
x5_ub  = 10e7;
x6_ub  = 10e7;
x7_ub  = 10e7;
x8_ub  = 10e7;
x9_ub  = 10e7;
x10_ub = 10e7;
x11_ub = 10e7;

x12_ub = 50e4;
x13_ub = 50e4;
x14_ub = 50e4;
x15_ub = 50e4;
x16_ub = 50e4;
x17_ub = 50e4;
x18_ub = 50e4;
x19_ub = 50e4;
x20_ub = 50e4;

x21_ub = 50e4;
x22_ub = 50e4;
x23_ub = 50e4;

x24_ub = 150e4;

u1_ub=1;
u2_ub=1;
u3_ub=1;
u4_ub=1;
u5_ub=1;
u6_ub=1;
u7_ub=1;

ubx = vertcat(x1_ub,x2_ub,x3_ub,x4_ub,x5_ub,x6_ub,x7_ub,x8_ub,x9_ub,x10_ub,x11_ub,x12_ub,x13_ub,x14_ub,x15_ub,x16_ub,x17_ub,...
    x18_ub,x19_ub,x20_ub,x21_ub,x22_ub,x23_ub,x24_ub);

ubu = vertcat(u1_ub,u2_ub,u3_ub,u4_ub,u5_ub,u6_ub,u7_ub);


% decision variables
w   = {};            % why does this work and why do we put w first what is w ? why do brackets differ ? 
w0  = [];            % why does this work and why do we put w first what is w ?
lbw = []; 
ubw = [];

% constraints
g   = {};
lbg = [];
ubg = [];


w   = {w{:},x,u};    % why does this work and why do we put w first what is w ? 
lbw = [lbw;lbx;lbu];
ubw = [ubw;ubx;ubu];
w0  = [w0;x0;u0];    % why does this work and why do we put w first what is w ?

%Add the system model as constraints
g   = {g{:},vertcat(diff,alg)};
lbg = [lbg;zeros(24,1)];
ubg = [ubg;zeros(24,1)];

%stage cost 
L   = -x23 +x19 +x16 +x13;  % max oil min gas % PI used to affect results
% L   = -x23;                 % max oil 
% L   = +x19 +x16 +x13;       % min gas

% Economic objective
J   = L;


nlp = struct('x',vertcat(w{:}),'f',J,'g',vertcat(g{:}));
solver = nlpsol('solver','ipopt',nlp);  %  NLP solver  IPOPT
sol = solver('x0',w0,'lbx',lbw,'ubx',ubw,'lbg',lbg,'ubg',ubg); % then we feed it values initial lower and upper bounds of x and g 

% Extracting solutions 
w_opt_SS = full(sol.x);
uSS=w_opt_SS(25:end);
xSS=w_opt_SS(1:24);
