function  [w,w0,J,u_nlp_opt,x_nlp_opt] = optProblem_net128_test0412(N,u0,p,x0,z0,xz0_measured,uSS,xSS)
 

% xz0_measured should be a column vector of length nx+xz 
% N pridiction horizon 
% u0 and x0 z0 are merley initial states 
% this optimization problem maximizes oil production from riser, while
% tries to simultaneuously minimize the injected gas into the system. the
% production chokes of the riser  and lifts are always fully opened



addpath('C:\Users\sarriyh\Downloads\casadi-matlabR2014b-v3.2.3')
import casadi.*

load('Qxzu.mat')




% Initial values these values could be changed for a better guess
% N= 20;
nx=11;
nz=13;
nu=7;
T=4000;
% T=200;

tf=T/N;


% lower and upper bounds x(diff and alg) and u 
%diff wells and riser 
x1_lb  = 1e-2;
x2_lb  = 1e-2;
x3_lb  = 1e-2;
x4_lb  = 1e-2;
x5_lb  = 1e-2;
x6_lb  = 1e-2;
x7_lb  = 1e-2;
x8_lb  = 1e-2;
x9_lb  = 1e-2;
x10_lb = 1e-2;
x11_lb = 1e-2;

%algebraic wells
x12_lb = 1e-2;
x13_lb = 1e-2;
x14_lb = 1e-2;
x15_lb = 1e-2;
x16_lb = 1e-2;
x17_lb = 1e-2;
x18_lb = 1e-2;
x19_lb = 1e-2;
x20_lb = 1e-2;

%algebraic riser
x21_lb = 1e-2;
x22_lb = 1e-2;
x23_lb = 1e-2;

%manifold pressure 
x24_lb = 0.1;

%DOF riser and wells
u1_lb=1;   
u2_lb=0.1;
u3_lb=1;   
u4_lb=0.1;    % works well also with mpc 
u5_lb=1;   
u6_lb=0.1;
u7_lb=0.1; 


% setting the above in a vertical concatenation( a seriec of inconnected
% things)
lbx = vertcat(x1_lb,x2_lb,x3_lb,x4_lb,x5_lb,x6_lb,x7_lb,x8_lb,x9_lb,x10_lb,x11_lb);

lbz = vertcat(x12_lb,x13_lb,x14_lb,x15_lb,x16_lb,x17_lb,x18_lb,x19_lb,x20_lb,x21_lb,x22_lb,x23_lb,x24_lb);

lbu = vertcat(u1_lb,u2_lb,u3_lb,u4_lb,u5_lb,u6_lb,u7_lb);


% same as above only for UPPER bounds
x1_ub  = 10;
x2_ub  = 10;
x3_ub  = 10;
x4_ub  = 10;
x5_ub  = 10;
x6_ub  = 10;
x7_ub  = 10;
x8_ub  = 10;
x9_ub  = 10;
x10_ub = 10;
x11_ub = 10;

x12_ub = 50;
x13_ub = 50;
x14_ub = 50;
x15_ub = 50;
x16_ub = 50;
x17_ub = 50;
x18_ub = 50;
x19_ub = 50;
x20_ub = 50;

x21_ub = 53;
x22_ub = 50;
x23_ub = 50; % this can be contrained by setting maximum amount of water however then production chokes of the lifts must be relaxed
%x23_ub = 50; 


x24_ub = 150;

u1_ub  =1;
u2_ub  =1;
u3_ub  =1;
u4_ub  =1;
u5_ub  =1;
u6_ub  =1;
u7_ub  =1;

ubx = vertcat(x1_ub,x2_ub,x3_ub,x4_ub,x5_ub,x6_ub,x7_ub,x8_ub,x9_ub,x10_ub,x11_ub);

ubz = vertcat(x12_ub,x13_ub,x14_ub,x15_ub,x16_ub,x17_ub,x18_ub,x19_ub,x20_ub,x21_ub,x22_ub,x23_ub,x24_ub);

ubu = vertcat(u1_ub,u2_ub,u3_ub,u4_ub,u5_ub,u6_ub,u7_ub);



% begin p!!!!!!!!!!!!!!!!!!!!!!!!!!!
% Definig all constants for each model PI,P_res,GOR, WC,K_pr
% GOR     = [0.15 ; 0.1 ; 0.15];     % for [well1 well2 well3]
% WC      = [0.15 ; 0.1 ; 0.05];     % for [well1 well2 well3]
% Kpr     = [2.8  ; 3.0 ; 3.2 ;3.4]; % for [well1 well2 well3 riser]

% p=[GOR(1),WC(1),Kpr(1),...
%    GOR(2),WC(2),Kpr(2),...
%    GOR(3),WC(3),Kpr(3),...
%    Kpr(4)];
%End p!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!





%%%%%%%%%%
% on this side we put the main ideas of collocation and then later add

uSS=uSS;
xSS=xSS;


% Collocation setup  double check  
[B,C,D,d]= collocationSetup();
% Build NLP solver 
% empty NLP 
w   = {};
w0  = [];
lbw = [];
ubw = [];
J   = 0;

g   = {};
lbg = [];
ubg = [];

% initial conditions
X0  = MX.sym('X0',nx); 
Z0  = MX.sym('Z0',nz);
w   = {w{:},X0,Z0};
w0  = [w0;x0;z0]; % what are those two values ? x0 z0 in nmpc gaslift defined dx0 z0
lbw = [lbw;lbx;lbz];
ubw = [ubw;ubx;ubz];



% Begin penalty 
ubd_du = vertcat(0.1,0.1,0.1,0.1,0.1,0.1,0.1);
lbd_du = vertcat(-0.1,-0.1,-0.1,-0.1,-0.1,-0.1,-0.1);
% End penalty 




% formulate NLP 
Xk=X0;
Zk=Z0;
Xkj={};
Zkj={};



g= {g{:},[X0;Z0]-[xz0_measured]}; % x0 closing the loop 
lbg=[lbg;zeros(nx+nz,1)];
ubg=[ubg;zeros(nx+nz,1)];

for k=0:N-1  
    Uk  =MX.sym(['U_' num2str(k)],nu); 
    w   ={w{:},Uk};
    lbw =[lbw;lbu];  
    ubw =[ubw;ubu];
    w0  =[w0;u0];
    
    % Regularization term for control 
        
    % the below can be added or not
    Jcontrol = (Uk-uSS)'*diag(Qxzu(nx+nz+1:end,1))*(Uk-uSS); % Add Q or R weighting , uSS (reference point)
    
    Xkj={};
    Zkj={};
    
    for j=1:d % d  degree of collo. polynomial ax^3 + bx^2 ...
        Xkj{j}=MX.sym(['X_' num2str(k) '_' num2str(j)],nx); % this looks like (nx)x1 casadi.MX vector in this case 11x1 []
        Zkj{j}=MX.sym(['Z_' num2str(k) '_' num2str(j)],nz);
        w   = {w{:},Xkj{j},Zkj{j}};
        w0  =[w0;x0;z0]; % initial values only
        lbw =[lbw;lbx;lbz];
        ubw =[ubw;ubx;ubz];
    end
    
    % loop over collocation points 
    
    Xk_end=D(1)*Xk; %D(1) is the coeff of continuity eq. at polynomial at final time 
    
    for j=1:d
        % Expression for the state derivative at the collocation point
        xp = C(1,j+1)*Xk;  %coeff of collocation equation C is a 4x4 matrix 
        
        
        for r=1:d 
            xp=xp+C(r+1,j+1)*Xkj{r};
        end
        
      
        model   = network_128(0,[Xkj{j};Zkj{j}],Uk,p); % here p is supplied
        diff    = model(1:11);                       %hard coded 
        alg     = model(12:24);
        
        g={g{:},tf*diff-xp,alg}; % dynamics and algebraic constraints 
        lbg = [lbg;zeros(nx,1);zeros(nz,1)];
        ubg = [ubg;zeros(nx,1);zeros(nz,1)];
       
        % add contribution to the states 
        Xk_end=Xk_end +D(j+1)*Xkj{j};    
        
       
    end
  
  % add control moves and penalty term in the objective Function 
  % Begin Penalty
    if k>0
        % Equality Constraint
        g = {g{:},(Uk_prev - Uk)};
        lbg = [lbg;lbd_du];
        ubg = [ubg;ubd_du];
        
        % Include Penalty Term In Objective function with weight 
        J_penalty= (Uk_prev-Uk)'*diag([ones(7,1)])*(Uk_prev-Uk); %weighting should be added 
        J=J+J_penalty;
    end
  % End Penalty 

    % New NLP variable for state at end of interval
    Xk      = MX.sym(['X_' num2str(k+1) ], nx);
    w       = {w{:},Xk};
    lbw     = [lbw;lbx];
    ubw     = [ubw;ubx];
    w0      = [w0; x0];
 
    % Shooting Gap constraint
    g   = {g{:},Xk_end-Xk};
    lbg = [lbg;zeros(nx,1)];
    ubg = [ubg;zeros(nx,1)];
           
  

    % regularization term for state variable
    Jstate =([Xk;Zkj{j}] - xSS)' *diag(Qxzu(1:nx+nz,1))* ([Xk;Zkj{j}] - xSS); % add a Q weighting 
    
     
    % economic objective state cost if you would like to have an economic
    % NMPC 
     Jecon  = -Zkj{j}(12)+Zkj{j}(8)+Zkj{j}(5)+Zkj{j}(2); % max oil min gas
%     Jecon2 = -Zkj{j}(12);                               % max oil 
%     Jecon3 = Zkj{j}(8)+Zkj{j}(5)+Zkj{j}(2);             % min gas



     % stage cost Cases    
% J = J + Jstate;                     % tracking only
% J = J + Jstate + Jcontrol;          % tracking and control 



% if u like to have an economic NMPC

J = J + Jecon + Jstate + Jcontrol;  % Mix tracking econ (stable)
% J = J + Jecon + Jcontrol;           % Mix econ control (less stable)
% J = J + Jecon;                      % Pure econ max oil min gas(unstable)

% J = J + Jecon2;                       % Pure econ max oil(Doesnt work)
% J = J + Jecon2 + Jstate + Jcontrol;  % Mix tracking econ2 (stable)

% J = J + Jecon3 + Jstate + Jcontrol;  % Mix tracking econ3 (stable)
% J = J + Jecon3 ;  %  econ3 (doesnt work)




% save previous inputs
Uk_prev=Uk;

end


nlp = struct('x',vertcat(w{:}),'f',J,'g',vertcat(g{:})); % note i removed p since there is no need for it 

% if you would like some extra options 
%     options = struct;
%     options.ipopt.tol       = 1e-12;
%     options.acceptable_compl_inf_tol    = 1e-6; 
%     solver = nlpsol('solver', 'ipopt', nlp, options);
solver = nlpsol('solver', 'ipopt', nlp); % i removed options for the time being 
%     sol         = solver('x0', w0, 'p', paramModel.GOR, 'lbx', lbw, 'ubx', ubw, 'lbg', lbg, 'ubg', ubg);
tic
sol = solver('x0',w0,'lbx',lbw,'ubx',ubw,'lbg',lbg,'ubg',ubg); % then we feed it values initial lower and upper bounds of x and g 
toc
w_opt_SS = full(sol.x); % 24 initial x0 z0 then 20 loops of 7 24 24 24 11 to get value take value every 90th 



% the below is to stop when solver Error 
    success = strcmp(solver.stats.return_status,'Infeasible_Problem_Detected');
    if (success)
        keyboard;
    end
    
    
    % this plotting function is taken from EKA 
[u_nlp_opt, x_nlp_opt] = plotStatesGL_test0412(w_opt_SS, lbw, ubw, N); 

end 
