clear 
clc
close all

x0 = [3.1933    0.5850    4.4132    3.3977    0.5601    5.0101    3.1600  ...
      0.5846    4.2971    0.2646    1.2903   15.6427    1.0425       15   14.3927  ...
      1.1855       20      14.6892    1.0511     28      48.0037    8.5439   39.4598   48.0963]';

u0 = [1;0.5;1;0.6;1;0.5;1];

% Definig all constants to each model PI,P_res,GOR, WC,K_pr
GOR     = [0.15 ; 0.1 ; 0.15];     % for [well1 well2 well3]
WC      = [0.15 ; 0.1 ; 0.05];     % for [well1 well2 well3]
Kpr     = [2.8  ; 3.0 ; 3.2 ;3.4]; % for [well1 well2 well3 riser]

p=[GOR(1),WC(1),Kpr(1),...
   GOR(2),WC(2),Kpr(2),...
   GOR(3),WC(3),Kpr(3),...
   Kpr(4)];



% RUN RTO 
[xSS,uSS]=RTO_network128(x0,u0,p);



    % Run Ode15s
M=diag([ones(1,11) zeros(1,13)]);
options=odeset('Mass',M);

FF= @(t,x) [eye(24,24) zeros(24,25)]*network_128(0,x,uSS,p);

% simulation run time 
ode_time=4000; 

tspan=0:1:ode_time-1; 
    % [t,xz] = ode15s(FF,tspan,[x0;z0],options);
[t,xz_ode] = ode15s(FF,tspan,xSS,options);



% extract ode15s outputs
outputs_append=[];

for n=1:1:ode_time
    % Passing extra parameters
panda=network_128(0,(xz_ode(n,:))',uSS,p);
    % Removing [differentials;residuals] 
panda(1:24)=[];
    % Appending outputs 
outputs_append=[outputs_append,panda];
end


% transforming outputs append to ode x 25 matrix
outputs_append=outputs_append';

save('plant_RTO.mat','xz_ode','uSS','xSS','outputs_append','t','p','u0','x0')



